# BEGIN SourceDeps(oneline):
BuildRequires(pre): rpm-build-perl rpm-build-python rpm-build-ruby
BuildRequires: gcc-c++ perl(Exporter.pm) perl(Glib.pm) perl(IO/Handle.pm) perl(IO/Select.pm) perl(Scalar/Util.pm) perl-podlators python-devel unzip
# END SourceDeps(oneline)
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%global codename DrO_o

Name:			xmms2
Summary: 		A modular audio framework and plugin architecture
Version:		0.8
Release:		alt2_8
License:		LGPLv2+ and GPLv2+ and BSD
Group:			Sound
# We can't use the upstream source tarball as-is, because it includes an mp4 decoder.
# http://downloads.sourceforge.net/xmms2/%{name}-%{version}%{codename}.tar.bz2
# Cleaning it is simple, just rm -rf src/plugins/mp4
Source0:		%{name}-%{version}%{codename}-clean.tar.bz2
Source1:		xmms2-client-launcher.sh
# Use libdir properly for Fedora multilib
Patch1:			xmms2-0.8DrO_o-use-libdir.patch
# Set default output to pulse
Patch2:			xmms2-0.8DrO_o-pulse-output-default.patch
# Don't add extra CFLAGS, we're smart enough, thanks.
Patch4:			xmms2-0.8DrO_o-no-O0.patch
# More sane versioning
Patch5:			xmms2-0.8DrO_o-moresaneversioning.patch
URL:			http://wiki.xmms2.xmms.se/
BuildRequires:		libsqlite3-devel libflac-devel libofa-devel
BuildRequires:		libcdio-devel libdiscid-devel libsmbclient-devel
BuildRequires:		libmpcdec-devel gnome-vfs-devel libjack-devel
BuildRequires:		libfftw3-devel libsamplerate-devel libxml2-devel libalsa-devel
BuildRequires:		libao-devel libshout2-devel python-module-Pyrex libruby-devel ruby
BuildRequires:		perl-devel boost-devel boost-filesystem-devel boost-wave-devel boost-graph-parallel-devel boost-math-devel boost-mpi-devel boost-program_options-devel boost-signals-devel boost-intrusive-devel boost-asio-devel libpulseaudio-devel libavahi-glib-devel
BuildRequires:		libmodplug-devel libecore-devel gamin-devel
BuildRequires:		libavahi-devel doxygen
BuildRequires:		libvisual0.4-devel libwavpack-devel libSDL-devel
BuildRequires:		glib2-devel readline-devel ncurses-devel
Source44: import.info

%description
XMMS2 is an audio framework, but it is not a general multimedia player - it 
will not play videos. It has a modular framework and plugin architecture for 
audio processing, visualisation and output, but this framework has not been 
designed to support video. Also the client-server design of XMMS2 (and the 
daemon being independent of any graphics output) practically prevents direct 
video output being implemented. It has support for a wide range of audio 
formats, which is expandable via plugins. It includes a basic CLI interface 
to the XMMS2 framework, but most users will want to install a graphical XMMS2 
client (such as gxmms2 or esperanza).

%package devel
Summary:	Development libraries and headers for XMMS2
Group:		Development/C
Requires:	%{name}%{?_isa} = %{version}-%{release}

%description devel
Development libraries and headers for XMMS2. You probably need this to develop
or build new plugins for XMMS2.

%package docs
Summary:	Development documentation for XMMS2
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description docs
API documentation for the XMMS2 modular audio framework architecture.

%package -n python-module-xmms2
Summary:	Python support for XMMS2
Group:		Sound
Requires:	%{name} = %{version}-%{release}

%description -n python-module-xmms2
Python bindings for XMMS2.

%package perl
Summary:	Perl support for XMMS2
License:	GPL+ or Artistic
Group:		Sound
Requires:	%{name} = %{version}-%{release}

%description perl
Perl bindings for XMMS2.

%package ruby
Summary:	Ruby support for XMMS2
Group:		Sound
Requires:	%{name} = %{version}-%{release}

%description ruby
Ruby bindings for XMMS2.

%package -n nyxmms2
Summary:	Commandline client for XMMS2
Group:		Sound
Requires:	%{name} = %{version}-%{release}

%description -n nyxmms2
nyxmms2 is the new official commandline client for XMMS2. It can be run in
either shell-mode (if started without arguments), or in inline-mode where
it executes the command passed as argument directly.

%prep
%setup -q -n %{name}-%{version}%{codename}
%patch1 -p1 -b .plugins-use-libdir
%patch2 -p1 -b .default-output-pulse
%patch4 -p1 -b .noO0
%patch5 -p1 -b .versionsanity

# This header doesn't need to be executable
chmod -x src/include/xmmsclient/xmmsclient++/dict.h

# Clean up paths in wafadmin
# WAFADMIN_FILES=`find wafadmin/ -type f`
# for i in $WAFADMIN_FILES; do
# 	sed -i 's|/usr/lib|%{_libdir}|g' $i
# done
# sed -i 's|"lib"|"%{_lib}"|g' wscript

%build
export CFLAGS="%{optflags}"
export CPPFLAGS="%{optflags}"
export LIBDIR="%{_libdir}"
export PYTHONDIR="%{python_sitelibdir}"
./waf configure --prefix=%{_prefix} --libdir=%{_libdir} --with-ruby-libdir=%{ruby_sitelibdir} --with-ruby-archdir=%{ruby_sitearchdir} \
  --with-perl-archdir=%{perl_vendor_archlib} --with-pkgconfigdir=%{_libdir}/pkgconfig -j1
./waf build -v %{?_smp_mflags}
# make the docs
doxygen

%install
export LIBDIR="%{_libdir}"
export python_LIBDEST="%{python_sitelibdir}"
./waf install --destdir=%{buildroot} --prefix=%{_prefix} --libdir=%{_libdir} --with-ruby-libdir=%{ruby_sitelibdir} --with-ruby-archdir=%{ruby_sitearchdir} \
  --with-perl-archdir=%{perl_vendor_archlib} --with-pkgconfigdir=%{_libdir}/pkgconfig

# exec flags for debuginfo
chmod +x %{buildroot}%{_libdir}/%{name}/* %{buildroot}%{_libdir}/libxmmsclient*.so* %{buildroot}%{python_sitelibdir}/xmmsclient/xmmsapi.so \
	%{buildroot}%{perl_vendor_archlib}/auto/Audio/XMMSClient/XMMSClient.so %{buildroot}%{ruby_sitearchdir}/xmmsclient_*.so

# Convert to utf-8
for i in %{buildroot}%{_mandir}/man1/*.gz; do
	gunzip $i;
done
for i in %{buildroot}%{_mandir}/man1/*.1 xmms2-0.8DrO_o.ChangeLog; do
	iconv -o $i.iso88591 -f iso88591 -t utf8 $i
	mv $i.iso88591 $i
done

install -m0755 %{SOURCE1} %{buildroot}%{_bindir}

%files
%doc AUTHORS xmms2-0.8DrO_o.ChangeLog COPYING COPYING.GPL COPYING.LGPL README TODO
%{_bindir}/%{name}*
%{_libdir}/libxmmsclient*.so.*
%{_libdir}/%{name}
%{_mandir}/man1/%{name}*
%{_datadir}/pixmaps/%{name}*
%{_datadir}/%{name}

%files devel
%{_includedir}/%{name}/
%{_libdir}/libxmmsclient*.so
%{_libdir}/pkgconfig/%{name}-*.pc

%files docs
%doc doc/xmms2/html

%files perl
%{perl_vendor_archlib}/Audio/
%{perl_vendor_archlib}/auto/Audio/

%files -n python-module-xmms2
%{python_sitelibdir}/xmmsclient/

%files ruby
%{ruby_sitelibdir}/xmmsclient.rb
%{ruby_sitelibdir}/xmmsclient/
%{ruby_sitearchdir}/xmmsclient_ecore.so
%{ruby_sitearchdir}/xmmsclient_ext.so
%{ruby_sitearchdir}/xmmsclient_glib.so

%files -n nyxmms2
%{_bindir}/nyxmms2

%changelog
* Mon Feb 11 2013 Igor Vlasenko <viy@altlinux.ru> 0.8-alt2_8
- update to new release by fcimport

* Sat Jan 19 2013 Igor Vlasenko <viy@altlinux.ru> 0.8-alt2_7
- next fc release

* Tue Dec 11 2012 Cronbuild Service <cronbuild@altlinux.org> 0.8-alt2_6
- rebuild to get rid of unmets

* Thu Aug 02 2012 Igor Vlasenko <viy@altlinux.ru> 0.8-alt1_6
- update to new release by fcimport

* Sat May 26 2012 Igor Vlasenko <viy@altlinux.ru> 0.8-alt1_4
- fc import

